#!/usr/bin/ruby
# note.rb: interactive card program
# written by tnomura in /05/07/2006

require 'yaml'

class Card
  def initialize(obj)
    @title = obj["title"]
    @doc = obj["doc"]
    @choice = obj["choice"]
    @link = obj["link"]
  end

  attr_reader :title

  def disp
    puts
    puts "[#{@title}]", @doc
    return nil unless @choice
    puts
    itemNo = 1
    @choice.each {|item| print "#{itemNo}: #{item}\t"; itemNo += 1}
    puts
    print "chose number > "
    i = gets.to_i - 1
    @link[i]
  end
end

card_table = {}

objects = YAML.load_stream(File.read(ARGV.shift)).documents
first_title = objects[0]["title"]

objects.each do |obj|
  card = Card.new(obj)
  card_table[card.title] = card
end

card = card_table[first_title]

while true
  next_card = card.disp
  card = card_table[next_card]
  break if not card
end
